<template>
    <li class="phrase-hit mdc-card">
        <div class="mdc-card-wrapper__text-selection">
            <div
                ref="input"
                class="mdc-card__content phrase-hit__card"
                :contenteditable="isEditing ? 'true' : 'false'"
                spellcheck="false"
                @blur="onPhraseChange($event, item)"
                @keypress.enter="$event.target.blur()"
                @click="onPhraseClick(item)"
            >{{ item.phrase }}</div>
        </div>
        <div
            v-if="isLoggedIn && hasOwnership"
            class="mdc-card__actions phrase-hit__toolbar"
            :style="`--display: ${isEditing ? 'none' : 'flex'}`"
        >
            <toolbar-button
                action="delete"
                @click="onDeleteClick(item, items, itemIndex)"
                :identifier="item.objectID"
                tooltip="Delete"
                icon="fa-trash"
            />
            <toolbar-button
                action="edit"
                :identifier="item.objectID"
                @click="onEditClick()"
                icon="fa-pencil-alt"
                tooltip="Edit"
            />
        </div>
    </li>
</template>
<script>
export default {
    props: ['item', 'items', 'itemIndex', 'isLoggedIn', 'currentItem', 'hasOwnership'],

    data() {
        return {
            isEditing: false,
        };
    },

    methods: {
        onPhraseChange(event, item) {
            axios.patch(`phrases/${item.objectID}`, {
                    phrase: event.target.innerText,
                })
                .then(() => {
                    this.$emit('phrase-updated');
                })
                .catch(error => {
                    this.$toasted.global.apiError(error);
                });

            this.isEditing = false;

            this.$emit('blur');
        },

        onPhraseClick(item) {
            this.$emit('on-phrase-click', item);
        },

        onEditClick() {
            this.isEditing = true;

            // Immediately set it as editable so it's focusable
            this.$refs.input.contentEditable = true;
            const element = this.$refs.input;
            const range = document.createRange();
            const selection = window.getSelection();
            range.setStart(element.childNodes[0], element.innerHTML.length);
            range.collapse(true);
            selection.removeAllRanges();
            selection.addRange(range);
            element.focus();
        },

        onDeleteClick(item, items, itemIndex) {
            axios.delete(`phrases/${item.objectID}`)
                .then(() => {
                    items.splice(itemIndex, 1);

                    this.$emit('phrase-deleted');
                })
                .catch(error => {
                    this.$toasted.global.apiError(error);
                });
        },
    },
};
</script>
<style>
.phrase-hit__toolbar {
    --display: flex;
    display: var(--display);
}

.phrase-hit__card {
    outline: none;
}

.mdc-card__content {
    padding: 16px;
}

.mdc-card__actions {
    opacity: 0;
    position: absolute;
    bottom: 0;
    background: rgba(250, 250, 250, .8);
    width: 100%;
    flex-direction: row-reverse;
}

.mdc-card:hover .mdc-card__actions {
    opacity: 1;
}

.phrase-hit {
    list-style: none;
    margin: .3rem;
    min-width: 100px;
    width: calc(25% - 1rem);
}

.ais-Hits-item-phrase {
    overflow-wrap: break-word;
}

.ais-Hits-item-container {
    display: flex;
    justify-content: space-between;
    position: relative;
}
</style>
